unit testspelling;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, nzcsspellcheck;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    a1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
      NZCSSpellCheck: TNZCSSpellCheck;
    procedure SpellClick(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation


{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
   X: Integer;
begin
   Try
      Memo1.SetFocus;
      X := Memo1.SelStart;
      Memo1.SelStart := 0;
      NZCSSpellCheck.CheckMemo(Memo1);
      Memo1.SelStart := X;
   finally
      If not NZCSSpellCheck.Cancelled then
         ShowMessage('The spelling check is complete.');
   end;
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
var
   Wd: String;
   Suggestions: TStringList;
   NewItem: TMenuItem;
   i: Integer;
begin
   Wd := NZCSSpellCheck.WordAtCursor(Memo1);
   PopupMenu1.Items.Clear;
   If (Wd <> '') and not NZCSSpellCheck.CheckWord(Wd) then begin
      Suggestions := TStringList.Create;
      If NZCSSpellCheck.GetSuggestions(Wd, Suggestions) then begin
         For i := 0 to Suggestions.Count - 1 do begin
            NewItem := TMenuItem.Create(PopupMenu1.Items);
            NewItem.Caption := Suggestions[i];
            NewItem.OnClick := SpellClick;
            PopupMenu1.Items.Add(NewItem);
         end;
      end;
      Suggestions.Free;
   end
   else
      Abort;
end;

procedure TForm1.SpellClick(Sender: TObject);
begin
   Memo1.SelText := StripDelimiter('&', TMenuItem(Sender).Caption);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   NZCSSpellCheck := TNZCSSpellCheck.Create(Application);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   NZCSSpellCheck.Free;
end;

end.
